#include <bits/stdc++.h>

using namespace std;

int a[50][50],n,m,q;
int suma_minimalna(int i,int j){
int sumica=a[1][1];
 while(a[i][j]!=a[n][m]){

    if(a[i+1][j]==-1){
        sumica+=a[i][j+1];
        j++;

    }
    else if(a[i][j+1]==-1 ){
        sumica+=a[i+1][j];
        i++;

    }
    else{
    if(a[i+1][j]<a[i][j+1])
    {
            sumica+=a[i+1][j];
            i++;
    }
    else {
        sumica+=a[i][j+1];
        j++;
    }}


    }
if(j!=m)
return sumica+a[n][m];
else
return sumica;

 }




int main()
{
    scanf("%d%d",&n,&m);
    for(int i=1;i<=n;i++)
     for(int j=1;j<=m;j++)
      scanf("%d",&a[i][j]);

      for(int i=1;i<=n;i++)
        a[i][m+1]=-1;

      for(int j=1;j<=m;j++)
        a[n+1][j]=-1;

scanf("%d",&q);
int tmp=-1,tmp1=-1;
    while(q--){
        int x,y;
        cin>>x>>y;
        swap(a[x][y],tmp);
        swap(a[x-1][y],tmp1);
       cout<<suma_minimalna(1,1)<<endl;
       swap(a[x][y],tmp);
       swap(a[x-1][y],tmp1);
    }

    return 0;
}